unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleServer, StdCtrls,Activex, Office_TLB,Excel_TLB,Clipbrd,
  ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    btnImportCarts: TButton;
    img1: TImage;
    pgcCharts: TPageControl;
    pnl1: TPanel;
    dlgOpen: TOpenDialog;
    stb1: TStatusBar;
    edtChartName: TEdit;
    lbl1: TLabel;
    procedure btnImportCartsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pgcChartsChange(Sender: TObject);
  private
    { Private declarations }
    PagesReady: Boolean;
  public
    { Public declarations }
    procedure ClearCharts;
  end;

var
  Form1: TForm1;
  Charts: TStringList;

function GetExcelChartImages(exlFileName: string;   //       
                             ChartList: TStrings;   //   items   ,  objects 
                             StartExcelNewInstance: Boolean=False  // True -    ""  Excel
                                                                   // False ( ) -   
                                                                   //  Excel.    - 
                             ): Boolean;


implementation

{$R *.dfm}


function GetExcelChartImages(exlFileName: string; ChartList: TStrings; StartExcelNewInstance: Boolean=False): Boolean;
var
 ExcelApp: TExcelApplication;
 WB: _Workbook;
 WBName: string;
 xCharts: ChartObjects;
 xChart: ChartObject;
 Crt: OleVariant;
 i,j: Integer;
 BMP: TBitmap;
 NeedCloseWb: Boolean;
begin
  NeedCloseWb := False;
  WBName := ExtractFileName(exlFileName); //        

  ExcelApp := TExcelApplication.Create(nil); //   TExcelApplication

  if StartExcelNewInstance then
    ExcelApp.ConnectKind := ckNewInstance
  else
    ExcelApp.ConnectKind := ckRunningOrNew;

  ExcelApp.Connect;  // 

  WB := nil;

  try
    if (ExcelApp.Workbooks.Count > 0) then
    begin
      //      
      for i := 1 to ExcelApp.Workbooks.Count do
      begin
        if (ExcelApp.Workbooks.Item[i].Name = WBName) then
        begin
          WB := ExcelApp.Workbooks.Item[i] as _Workbook;
          Break;
        end;
      end;
    end;

    if (WB = nil) then   //    - 
    begin
      WB := ExcelApp.Workbooks.Open(exlFileName, EmptyParam, EmptyParam, EmptyParam,
                   EmptyParam, EmptyParam, EmptyParam, EmptyParam, EmptyParam,
                   EmptyParam, EmptyParam, EmptyParam, False, EmptyParam, EmptyParam, 0);
      NeedCloseWb := True; //   ,   
    end;

    xCharts := nil;

    for i := 1 to WB.Worksheets.Count do //    ,  
    begin
      xCharts := ((WB.Worksheets.Item[i] as _Worksheet).ChartObjects(EmptyParam, 0) as ChartObjects);

      if Assigned(xCharts) then
      begin
        xChart := nil;
        for j := 1 to xCharts.Count do  //      
        begin
           xChart := xCharts.Item(j) as ChartObject;

           if Assigned(xChart) then
           begin
             ClipBoard.Clear;                        //    (  )
             xChart.CopyPicture(xlScreen,xlBitmap);  //       

             BMP := TBitmap.Create;                  //     
             BMP.LoadFromClipboardFormat(CF_BITMAP,ClipBoard.GetAsHandle(cf_Bitmap), 0);

             Crt := xChart.Chart;
             if (Crt.HasTitle = True) then           //      
                                                     //     
               ChartList.AddObject(Crt.ChartTitle.Text,BMP)
             else                                    //     " " 
               ChartList.AddObject(Crt.Name,BMP);
           end;
           BMP := nil;
           xChart := nil;
        end;

      end;
      xCharts := nil;
    end;

    if NeedCloseWb then                              //   -   
      WB.Close(False,EmptyParam,EmptyParam,0);

  finally
    ClipBoard.Clear;                                 //     
    Result := (ChartList.Count > 0);

    if StartExcelNewInstance then                   //      Excel
    begin                                           //    ""
      if Assigned(ExcelApp) then
      begin
        if (ExcelApp.Workbooks.Count > 0) and (not ExcelApp.Visible[0]) then
        begin
          ExcelApp.WindowState[0] := TOLEEnum(xlMinimized);
          ExcelApp.Visible[0] := true;
          Application.BringToFront;
        end;
      end;
      FreeAndNil(ExcelApp);
    end
    else                                          //     -  
    begin
      ExcelApp.Disconnect;
      ExcelApp.Free;
    end;
  end;
end;


procedure TForm1.ClearCharts;
var
 i: Integer;
 BMP: TBitmap;
begin
  PagesReady := False;
  img1.Visible := False;
  img1.Parent := Self;
  img1.Picture.Bitmap := nil;
  for i := 0 to Charts.Count-1 do
  begin
    BMP := TBitmap(Charts.Objects[i]);
    FreeAndNil(BMP);
  end;

  for i := pgcCharts.PageCount-1 downto 0 do
    pgcCharts.Pages[i].Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PagesReady := False;
  Charts := TStringList.Create;
  dlgOpen.InitialDir := ExtractFileDir(Application.ExeName);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ClearCharts;
  Charts.Free;
end;


procedure TForm1.btnImportCartsClick(Sender: TObject);
var
  i,pg: Integer;
  ChartSheet: TTabSheet;
  BMP: TBitmap;
begin

  ClearCharts;                               //     (  )

  if dlgOpen.Execute and GetExcelChartImages(dlgOpen.FileName,Charts) then
  begin

    for i := 0 to Charts.Count -1 do         //  ,    
    begin
      ChartSheet := TTabSheet.Create(pgcCharts);
      ChartSheet.PageControl := pgcCharts;
      ChartSheet.Caption  := Charts[i];
      ChartSheet.Tag := i;                  //      
      ChartSheet.Visible := True;
      ChartSheet.TabVisible := True;
    end;


    ChartSheet := nil;
    pg := Charts.IndexOf(edtChartName.Text);  //      
    if (pg < 0) then pg := 0;                 //    -    

    BMP := TBitmap(Charts.Objects[pg]);       //   Objects 
    for i := 0 to pgcCharts.PageCount -1 do
      if (pgcCharts.Pages[i].Tag = pg) then
      begin
        ChartSheet := pgcCharts.Pages[i];
        Break;
      end;


    img1.Picture.Bitmap := BMP;             // 
    img1.Parent := ChartSheet;
    pgcCharts.ActivePage := ChartSheet;
    img1.Visible := True;

    PagesReady := True;
  end;

end;

procedure TForm1.pgcChartsChange(Sender: TObject);
var
  BMP: TBitmap;
begin
  if not PagesReady then Exit;

  BMP := TBitmap(Charts.Objects[pgcCharts.ActivePage.Tag]);       //   Objects 
  img1.Visible := False;                     //  
  img1.Picture.Bitmap := BMP;                //  
  img1.Parent := pgcCharts.ActivePage;       // ""    
  img1.Visible := True;                      //  

end;

end.
